VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cfLiqKat"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private WithEvents mfLiqKat As cWidgetForm        'Presenter
Attribute mfLiqKat.VB_VarHelpID = -1
Private WithEvents mWV As cWebView2               'Browser
Attribute mWV.VB_VarHelpID = -1
Private mLiqPlan As cmLiqPlan                     'Daten
Private mLoadTemplateComplete As Boolean
Public Event DialogAction(action As String)

Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_HWNDPARENT As Long = -8&


Private Sub Class_Initialize()
    On Error Resume Next
    Set mfLiqKat = Cairo.WidgetForms.Create(vbSizableToolWindow, "Kategorien verwalten")
    mfLiqKat.IconImageKey = "progIcn" 'Fenster-Icon
End Sub

Public Sub Show(parent As cWidgetForm, liqPlan As cmLiqPlan)
Const w As Long = 600, h As Long = 400
Dim l As Long, t As Long
    On Error GoTo Show_Error
    Set mLiqPlan = liqPlan
    Set mWV = WinHelper.BindWebView(mfLiqKat)                      'Browser anbinden
    If Not mWV Is Nothing Then
        loadTemplate
        mWV.jsRun "FillData", mLiqPlan.GetJSONKat
    End If
    l = parent.Left + ((parent.Width - w) \ 2)
    t = parent.Top + 100
    With mfLiqKat
        .StartUpPosition = vbStartUpManual
        .Move l, t, w, h
        .Show
        SetWindowLong .hwnd, GWL_HWNDPARENT, parent.hwnd
    End With
    
    Exit Sub
    
Show_Error:
    Err.Raise Err.Number, _
     "cfLiqPlan.Show." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Sub


Private Sub mfLiqKat_Unload(Cancel As Integer)
    On Error Resume Next
    RaiseEvent DialogAction("OnUnload")
End Sub

Private Sub mWV_AcceleratorKeyPressed(ByVal KeyState As RC6.eWebView2AccKeyState, ByVal IsExtendedKey As Boolean, ByVal WasKeyDown As Boolean, ByVal IsKeyReleased As Boolean, ByVal IsMenuKeyDown As Boolean, ByVal RepeatCount As Long, ByVal ScanCode As Long, IsHandled As Boolean)
Const wvKeyF5 As Long = 63
    If ScanCode = wvKeyF5 Then
        If App.LogMode Then IsHandled = True
    End If
End Sub

Private Sub mWV_DocumentComplete()
    On Error Resume Next
    mWV.jsRun "Init"
    mLoadTemplateComplete = True
End Sub


Private Function loadTemplate() As Boolean
Dim template As String
    On Error GoTo loadTemplate_Error
    mLoadTemplateComplete = False
    If HtmlHelper.ReadFromRes Then
        mWV.Navigate "file:///" & Replace(AppPath, "\", "/") & "/Res/liqkat.html"
    Else
        template = HtmlHelper.Crypt.UTF8ToVBString(HtmlHelper.AppRes.GetContent("liqkat.html"))
        mWV.NavigateToString template
        mWV.jsProp("document.title") = "Kategorien"
    End If
    Do Until mLoadTemplateComplete
        DoEvents
    Loop
    loadTemplate = True
    Exit Function
    
loadTemplate_Error:
    Err.Raise Err.Number, _
     "mfLiqKat.loadTemplate." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function


Private Sub mfLiqKat_GotFocus()
    On Error Resume Next
    If Not mWV Is Nothing Then mWV.SetFocus
End Sub

Private Sub mfLiqKat_Resize()
    If mfLiqKat.WindowState <> vbMinimized Then
        If Not mWV Is Nothing Then mWV.SyncSizeToHostWindow
    End If
End Sub

Private Sub mWV_JSMessage(ByVal sMsg As String, ByVal sMsgContent As String, oJSONContent As RC6.cCollection)
Dim id As Long
Dim s As String
    On Error GoTo mWV_JSMessage_Error
    Select Case True
        Case sMsg Like "change::txtBez*"
            s = Mid$(sMsg, 15)
            If IsNumeric(s) Then
                id = CLng(s)
                mLiqPlan.UpdateKatBen id:=id, Benennung:=sMsgContent
            End If
        Case sMsg Like "change::txtKat*"
            s = Mid$(sMsg, 15)
            id = CLng(Val(s))
            mLiqPlan.UpdateKatKat id:=id, Kat:=sMsgContent

        Case sMsg = "click"
            Select Case True
                Case sMsgContent = "addKat"
                    id = mLiqPlan.AddKat
                    If id > 0 Then mWV.jsRun "AddKat", id
                Case sMsgContent Like "delKat*"
                    id = CLng(Mid$(sMsgContent, 7))
                    If mLiqPlan.DelKat(id) Then mWV.jsRun "DelKat", id
                Case sMsgContent = "closeKat"
                    mfLiqKat.Unload
            End Select
    End Select
        
    Exit Sub
        
mWV_JSMessage_Error:
        Screen.MousePointer = vbDefault
        MsgBox "Fehler: " & Err.Number & vbCrLf & _
         "Beschreibung: " & Err.Description & vbCrLf & _
         "Quelle: mfLiqKat.mWV_JSMessage." & Erl & vbCrLf & Err.Source, _
         vbCritical
End Sub

